Loading...
1#!/bin/bash
2# SPDX-License-Identifier: GPL-2.0
3# Linux kernel coccicheck
4#
5# Read Documentation/dev-tools/coccinelle.rst
6#
7# This script requires at least spatch
8# version 1.0.0-rc11.
9
10DIR="$(dirname $(readlink -f $0))/.."
11SPATCH="`which ${SPATCH:=spatch}`"
12
13if [ ! -x "$SPATCH" ]; then
14 echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
15 exit 1
16fi
17
18SPATCH_VERSION=$($SPATCH --version | head -1 | awk '{print $3}')
19SPATCH_VERSION_NUM=$(echo $SPATCH_VERSION | ${DIR}/scripts/ld-version.sh)
20
21USE_JOBS="no"
22$SPATCH --help | grep "\-\-jobs" > /dev/null && USE_JOBS="yes"
23
24# The verbosity may be set by the environmental parameter V=
25# as for example with 'make V=1 coccicheck'
26
27if [ -n "$V" -a "$V" != "0" ]; then
28 VERBOSE="$V"
29else
30 VERBOSE=0
31fi
32
33FLAGS="--very-quiet"
34
35# You can use SPFLAGS to append extra arguments to coccicheck or override any
36# heuristics done in this file as Coccinelle accepts the last options when
37# options conflict.
38#
39# A good example for use of SPFLAGS is if you want to debug your cocci script,
40# you can for instance use the following:
41#
42# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
43# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
44#
45# "--show-trying" should show you what rule is being processed as it goes to
46# stdout, you do not need a debug file for that. The profile output will be
47# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
48# inspected there.
49#
50# --profile will not output if --very-quiet is used, so avoid it.
51echo $SPFLAGS | egrep -e "--profile|--show-trying" 2>&1 > /dev/null
52if [ $? -eq 0 ]; then
53 FLAGS="--quiet"
54fi
55
56# spatch only allows include directories with the syntax "-I include"
57# while gcc also allows "-Iinclude" and "-include include"
58COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
59COCCIINCLUDE=${COCCIINCLUDE// -include/ --include}
60
61if [ "$C" = "1" -o "$C" = "2" ]; then
62 ONLINE=1
63
64 # Take only the last argument, which is the C file to test
65 shift $(( $# - 1 ))
66 OPTIONS="$COCCIINCLUDE $1"
67
68 # No need to parallelize Coccinelle since this mode takes one input file.
69 NPROC=1
70else
71 ONLINE=0
72 if [ "$KBUILD_EXTMOD" = "" ] ; then
73 OPTIONS="--dir $srctree $COCCIINCLUDE"
74 else
75 OPTIONS="--dir $KBUILD_EXTMOD $COCCIINCLUDE"
76 fi
77
78 if [ -z "$J" ]; then
79 NPROC=$(getconf _NPROCESSORS_ONLN)
80 else
81 NPROC="$J"
82 fi
83fi
84
85if [ "$KBUILD_EXTMOD" != "" ] ; then
86 OPTIONS="--patch $srctree $OPTIONS"
87fi
88
89# You can override by using SPFLAGS
90if [ "$USE_JOBS" = "no" ]; then
91 trap kill_running SIGTERM SIGINT
92 declare -a SPATCH_PID
93elif [ "$NPROC" != "1" ]; then
94 # Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
95 # https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
96 OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
97fi
98
99if [ "$MODE" = "" ] ; then
100 if [ "$ONLINE" = "0" ] ; then
101 echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
102 echo 'Available modes are the following: patch, report, context, org'
103 echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
104 echo 'Note however that some modes are not implemented by some semantic patches.'
105 fi
106 MODE="report"
107fi
108
109if [ "$MODE" = "chain" ] ; then
110 if [ "$ONLINE" = "0" ] ; then
111 echo 'You have selected the "chain" mode.'
112 echo 'All available modes will be tried (in that order): patch, report, context, org'
113 fi
114elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
115 FLAGS="--no-show-diff $FLAGS"
116fi
117
118if [ "$ONLINE" = "0" ] ; then
119 echo ''
120 echo 'Please check for false positives in the output before submitting a patch.'
121 echo 'When using "patch" mode, carefully review the patch before submitting it.'
122 echo ''
123fi
124
125run_cmd_parmap() {
126 if [ $VERBOSE -ne 0 ] ; then
127 echo "Running ($NPROC in parallel): $@"
128 fi
129 echo $@ >>$DEBUG_FILE
130 $@ 2>>$DEBUG_FILE
131 err=$?
132 if [[ $err -ne 0 ]]; then
133 echo "coccicheck failed"
134 exit $err
135 fi
136}
137
138run_cmd_old() {
139 local i
140 if [ $VERBOSE -ne 0 ] ; then
141 echo "Running ($NPROC in parallel): $@"
142 fi
143 for i in $(seq 0 $(( NPROC - 1)) ); do
144 eval "$@ --max $NPROC --index $i &"
145 SPATCH_PID[$i]=$!
146 if [ $VERBOSE -eq 2 ] ; then
147 echo "${SPATCH_PID[$i]} running"
148 fi
149 done
150 wait
151}
152
153run_cmd() {
154 if [ "$USE_JOBS" = "yes" ]; then
155 run_cmd_parmap $@
156 else
157 run_cmd_old $@
158 fi
159}
160
161kill_running() {
162 for i in $(seq 0 $(( NPROC - 1 )) ); do
163 if [ $VERBOSE -eq 2 ] ; then
164 echo "Killing ${SPATCH_PID[$i]}"
165 fi
166 kill ${SPATCH_PID[$i]} 2>/dev/null
167 done
168}
169
170# You can override heuristics with SPFLAGS, these must always go last
171OPTIONS="$OPTIONS $SPFLAGS"
172
173coccinelle () {
174 COCCI="$1"
175
176 OPT=`grep "Options:" $COCCI | cut -d':' -f2`
177 REQ=`grep "Requires:" $COCCI | cut -d':' -f2 | sed "s| ||"`
178 REQ_NUM=$(echo $REQ | ${DIR}/scripts/ld-version.sh)
179 if [ "$REQ_NUM" != "0" ] ; then
180 if [ "$SPATCH_VERSION_NUM" -lt "$REQ_NUM" ] ; then
181 echo "Skipping coccinelle SmPL patch: $COCCI"
182 echo "You have coccinelle: $SPATCH_VERSION"
183 echo "This SmPL patch requires: $REQ"
184 return
185 fi
186 fi
187
188# The option '--parse-cocci' can be used to syntactically check the SmPL files.
189#
190# $SPATCH -D $MODE $FLAGS -parse_cocci $COCCI $OPT > /dev/null
191
192 if [ $VERBOSE -ne 0 -a $ONLINE -eq 0 ] ; then
193
194 FILE=${COCCI#$srctree/}
195
196 echo "Processing `basename $COCCI`"
197 echo "with option(s) \"$OPT\""
198 echo ''
199 echo 'Message example to submit a patch:'
200
201 sed -ne 's|^///||p' $COCCI
202
203 if [ "$MODE" = "patch" ] ; then
204 echo ' The semantic patch that makes this change is available'
205 elif [ "$MODE" = "report" ] ; then
206 echo ' The semantic patch that makes this report is available'
207 elif [ "$MODE" = "context" ] ; then
208 echo ' The semantic patch that spots this code is available'
209 elif [ "$MODE" = "org" ] ; then
210 echo ' The semantic patch that makes this Org report is available'
211 else
212 echo ' The semantic patch that makes this output is available'
213 fi
214 echo " in $FILE."
215 echo ''
216 echo ' More information about semantic patching is available at'
217 echo ' http://coccinelle.lip6.fr/'
218 echo ''
219
220 if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
221 echo 'Semantic patch information:'
222 sed -ne 's|^//#||p' $COCCI
223 echo ''
224 fi
225 fi
226
227 if [ "$MODE" = "chain" ] ; then
228 run_cmd $SPATCH -D patch \
229 $FLAGS --cocci-file $COCCI $OPT $OPTIONS || \
230 run_cmd $SPATCH -D report \
231 $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
232 run_cmd $SPATCH -D context \
233 $FLAGS --cocci-file $COCCI $OPT $OPTIONS || \
234 run_cmd $SPATCH -D org \
235 $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
236 elif [ "$MODE" = "rep+ctxt" ] ; then
237 run_cmd $SPATCH -D report \
238 $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
239 run_cmd $SPATCH -D context \
240 $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
241 else
242 run_cmd $SPATCH -D $MODE $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
243 fi
244
245}
246
247if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
248 if [ -f $DEBUG_FILE ]; then
249 echo "Debug file $DEBUG_FILE exists, bailing"
250 exit
251 fi
252else
253 DEBUG_FILE="/dev/null"
254fi
255
256if [ "$COCCI" = "" ] ; then
257 for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
258 coccinelle $f
259 done
260else
261 coccinelle $COCCI
262fi
1#!/bin/bash
2# Linux kernel coccicheck
3#
4# Read Documentation/dev-tools/coccinelle.rst
5#
6# This script requires at least spatch
7# version 1.0.0-rc11.
8
9DIR="$(dirname $(readlink -f $0))/.."
10SPATCH="`which ${SPATCH:=spatch}`"
11
12if [ ! -x "$SPATCH" ]; then
13 echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
14 exit 1
15fi
16
17SPATCH_VERSION=$($SPATCH --version | head -1 | awk '{print $3}')
18SPATCH_VERSION_NUM=$(echo $SPATCH_VERSION | ${DIR}/scripts/ld-version.sh)
19
20USE_JOBS="no"
21$SPATCH --help | grep "\-\-jobs" > /dev/null && USE_JOBS="yes"
22
23# The verbosity may be set by the environmental parameter V=
24# as for example with 'make V=1 coccicheck'
25
26if [ -n "$V" -a "$V" != "0" ]; then
27 VERBOSE="$V"
28else
29 VERBOSE=0
30fi
31
32if [ -z "$J" ]; then
33 NPROC=$(getconf _NPROCESSORS_ONLN)
34else
35 NPROC="$J"
36fi
37
38FLAGS="--very-quiet"
39
40# You can use SPFLAGS to append extra arguments to coccicheck or override any
41# heuristics done in this file as Coccinelle accepts the last options when
42# options conflict.
43#
44# A good example for use of SPFLAGS is if you want to debug your cocci script,
45# you can for instance use the following:
46#
47# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
48# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
49#
50# "--show-trying" should show you what rule is being processed as it goes to
51# stdout, you do not need a debug file for that. The profile output will be
52# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
53# inspected there.
54#
55# --profile will not output if --very-quiet is used, so avoid it.
56echo $SPFLAGS | egrep -e "--profile|--show-trying" 2>&1 > /dev/null
57if [ $? -eq 0 ]; then
58 FLAGS="--quiet"
59fi
60
61# spatch only allows include directories with the syntax "-I include"
62# while gcc also allows "-Iinclude" and "-include include"
63COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
64COCCIINCLUDE=${COCCIINCLUDE// -include/ --include}
65
66if [ "$C" = "1" -o "$C" = "2" ]; then
67 ONLINE=1
68
69 # Take only the last argument, which is the C file to test
70 shift $(( $# - 1 ))
71 OPTIONS="$COCCIINCLUDE $1"
72else
73 ONLINE=0
74 if [ "$KBUILD_EXTMOD" = "" ] ; then
75 OPTIONS="--dir $srctree $COCCIINCLUDE"
76 else
77 OPTIONS="--dir $KBUILD_EXTMOD $COCCIINCLUDE"
78 fi
79fi
80
81if [ "$KBUILD_EXTMOD" != "" ] ; then
82 OPTIONS="--patch $srctree $OPTIONS"
83fi
84
85# You can override by using SPFLAGS
86if [ "$USE_JOBS" = "no" ]; then
87 trap kill_running SIGTERM SIGINT
88 declare -a SPATCH_PID
89elif [ "$NPROC" != "1" ]; then
90 # Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
91 # https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
92 OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
93fi
94
95if [ "$MODE" = "" ] ; then
96 if [ "$ONLINE" = "0" ] ; then
97 echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
98 echo 'Available modes are the following: patch, report, context, org'
99 echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
100 echo 'Note however that some modes are not implemented by some semantic patches.'
101 fi
102 MODE="report"
103fi
104
105if [ "$MODE" = "chain" ] ; then
106 if [ "$ONLINE" = "0" ] ; then
107 echo 'You have selected the "chain" mode.'
108 echo 'All available modes will be tried (in that order): patch, report, context, org'
109 fi
110elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
111 FLAGS="--no-show-diff $FLAGS"
112fi
113
114if [ "$ONLINE" = "0" ] ; then
115 echo ''
116 echo 'Please check for false positives in the output before submitting a patch.'
117 echo 'When using "patch" mode, carefully review the patch before submitting it.'
118 echo ''
119fi
120
121run_cmd_parmap() {
122 if [ $VERBOSE -ne 0 ] ; then
123 echo "Running ($NPROC in parallel): $@"
124 fi
125 if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
126 if [ -f $DEBUG_FILE ]; then
127 echo "Debug file $DEBUG_FILE exists, bailing"
128 exit
129 fi
130 else
131 DEBUG_FILE="/dev/null"
132 fi
133 $@ 2>$DEBUG_FILE
134 if [[ $? -ne 0 ]]; then
135 echo "coccicheck failed"
136 exit $?
137 fi
138}
139
140run_cmd_old() {
141 local i
142 if [ $VERBOSE -ne 0 ] ; then
143 echo "Running ($NPROC in parallel): $@"
144 fi
145 for i in $(seq 0 $(( NPROC - 1)) ); do
146 eval "$@ --max $NPROC --index $i &"
147 SPATCH_PID[$i]=$!
148 if [ $VERBOSE -eq 2 ] ; then
149 echo "${SPATCH_PID[$i]} running"
150 fi
151 done
152 wait
153}
154
155run_cmd() {
156 if [ "$USE_JOBS" = "yes" ]; then
157 run_cmd_parmap $@
158 else
159 run_cmd_old $@
160 fi
161}
162
163kill_running() {
164 for i in $(seq 0 $(( NPROC - 1 )) ); do
165 if [ $VERBOSE -eq 2 ] ; then
166 echo "Killing ${SPATCH_PID[$i]}"
167 fi
168 kill ${SPATCH_PID[$i]} 2>/dev/null
169 done
170}
171
172# You can override heuristics with SPFLAGS, these must always go last
173OPTIONS="$OPTIONS $SPFLAGS"
174
175coccinelle () {
176 COCCI="$1"
177
178 OPT=`grep "Option" $COCCI | cut -d':' -f2`
179 REQ=`grep "Requires" $COCCI | cut -d':' -f2 | sed "s| ||"`
180 REQ_NUM=$(echo $REQ | ${DIR}/scripts/ld-version.sh)
181 if [ "$REQ_NUM" != "0" ] ; then
182 if [ "$SPATCH_VERSION_NUM" -lt "$REQ_NUM" ] ; then
183 echo "Skipping coccinele SmPL patch: $COCCI"
184 echo "You have coccinelle: $SPATCH_VERSION"
185 echo "This SmPL patch requires: $REQ"
186 return
187 fi
188 fi
189
190# The option '--parse-cocci' can be used to syntactically check the SmPL files.
191#
192# $SPATCH -D $MODE $FLAGS -parse_cocci $COCCI $OPT > /dev/null
193
194 if [ $VERBOSE -ne 0 -a $ONLINE -eq 0 ] ; then
195
196 FILE=`echo $COCCI | sed "s|$srctree/||"`
197
198 echo "Processing `basename $COCCI`"
199 echo "with option(s) \"$OPT\""
200 echo ''
201 echo 'Message example to submit a patch:'
202
203 sed -ne 's|^///||p' $COCCI
204
205 if [ "$MODE" = "patch" ] ; then
206 echo ' The semantic patch that makes this change is available'
207 elif [ "$MODE" = "report" ] ; then
208 echo ' The semantic patch that makes this report is available'
209 elif [ "$MODE" = "context" ] ; then
210 echo ' The semantic patch that spots this code is available'
211 elif [ "$MODE" = "org" ] ; then
212 echo ' The semantic patch that makes this Org report is available'
213 else
214 echo ' The semantic patch that makes this output is available'
215 fi
216 echo " in $FILE."
217 echo ''
218 echo ' More information about semantic patching is available at'
219 echo ' http://coccinelle.lip6.fr/'
220 echo ''
221
222 if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
223 echo 'Semantic patch information:'
224 sed -ne 's|^//#||p' $COCCI
225 echo ''
226 fi
227 fi
228
229 if [ "$MODE" = "chain" ] ; then
230 run_cmd $SPATCH -D patch \
231 $FLAGS --cocci-file $COCCI $OPT $OPTIONS || \
232 run_cmd $SPATCH -D report \
233 $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
234 run_cmd $SPATCH -D context \
235 $FLAGS --cocci-file $COCCI $OPT $OPTIONS || \
236 run_cmd $SPATCH -D org \
237 $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
238 elif [ "$MODE" = "rep+ctxt" ] ; then
239 run_cmd $SPATCH -D report \
240 $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
241 run_cmd $SPATCH -D context \
242 $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
243 else
244 run_cmd $SPATCH -D $MODE $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
245 fi
246
247}
248
249if [ "$COCCI" = "" ] ; then
250 for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
251 coccinelle $f
252 done
253else
254 coccinelle $COCCI
255fi